import { defineConfig, copy, equal, generateId, removeProperties } from '@agile-ts/utils';
import { Observer } from '../../runtime/observer.js';
import { RuntimeJob } from '../../runtime/runtime.job.js';

var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
class GroupObserver extends Observer {
  constructor(group, config = {}) {
    super(group.agileInstance(), defineConfig(config, { value: group._output }));
    this.group = () => group;
    this.nextGroupOutput = copy(group._output);
  }
  ingest(config = {}) {
    this.ingestOutput(this.group().nextGroupOutput, config);
  }
  ingestOutput(newGroupOutput, config = {}) {
    var _a;
    const group = this.group();
    config = defineConfig(config, {
      perform: true,
      force: false
    });
    if (group.isPlaceholder) {
      config.force = true;
    }
    this.nextGroupOutput = copy(newGroupOutput);
    if (equal(group._output, this.nextGroupOutput) && !config.force)
      return;
    const job = new RuntimeJob(this, __spreadValues(__spreadValues({}, removeProperties(config, ["perform"])), {
      key: (_a = config.key) != null ? _a : `${this._key != null ? this._key + "_" : ""}${generateId()}_output`
    }));
    this.agileInstance().runtime.ingest(job, {
      perform: config.perform
    });
  }
  perform(job) {
    const observer = job.observer;
    const group = observer.group();
    group._output = copy(observer.nextGroupOutput);
    group.nextGroupOutput = copy(observer.nextGroupOutput);
    job.observer.previousValue = copy(job.observer.value);
    job.observer.value = copy(group._output);
  }
}

export { GroupObserver };
