import { defineConfig, generateId } from '@agile-ts/utils';
import { RuntimeJob } from './runtime.job.js';
import { LogCodeManager } from '../logCodeManager.js';

class Observer {
  constructor(agileInstance, config = {}) {
    this.dependents = new Set();
    this.subscribedTo = new Set();
    var _a, _b;
    config = defineConfig(config, {
      dependents: [],
      subs: []
    });
    this.agileInstance = () => agileInstance;
    this._key = config.key;
    this.value = config.value;
    this.previousValue = config.value;
    (_a = config.dependents) == null ? void 0 : _a.forEach((observer) => this.addDependent(observer));
    (_b = config.subs) == null ? void 0 : _b.forEach((subscriptionContainer) => subscriptionContainer.addSubscription(this));
  }
  set key(value) {
    this._key = value;
  }
  get key() {
    return this._key;
  }
  ingest(config = {}) {
    var _a;
    config = defineConfig(config, {
      perform: true,
      background: false,
      sideEffects: {
        enabled: true,
        exclude: []
      },
      force: false
    });
    const job = new RuntimeJob(this, {
      force: config.force,
      sideEffects: config.sideEffects,
      background: config.background,
      key: (_a = config.key) != null ? _a : `${this._key != null ? this._key + "_" : ""}${generateId()}`
    });
    this.agileInstance().runtime.ingest(job, {
      perform: config.perform
    });
  }
  perform(job) {
    LogCodeManager.log("17:03:00");
  }
  addDependent(observer) {
    if (!this.dependents.has(observer))
      this.dependents.add(observer);
  }
  removeDependent(observer) {
    if (this.dependents.has(observer))
      this.dependents.delete(observer);
  }
}

export { Observer };
